//--------------------------------------------------------------------------
//Copyright(c) 2009, WenZhong Sun<wanmyqawdr@126.com>
//--------------------------------------------------------------------------
//This file is part of ARMV4T_and_FPGA_based_DSO
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

//--------------------------------------------------------------------------
//--------------------------------------------------------------------------

#ifndef _DFF_API_H_
#define _DFF_API_H_

#ifdef __cplusplus
extern"C"{
#endif

#include "../src/ddf/uid.h"
#include "../src/ddf/ddf_type.h"
#include "../src/ddf/ddf_val.h"
#include "../src/ddf/ioctl.h"
#include "../src/mini2440/driver/device_id.h"
#include "../src/mini2440/target/S3C2440_regs.h"

#define BEGIN_IO_REQUEST_MAP(_io_req_map) \
            static const IO_REQ _io_req_map[] = {            
            
#define IOCTL_ROUTINE(ioctl, routine) \
                {(ioctl), (routine)},    
                
#define END_IO_REQUEST_MAP() \
                {0, 0}}; 

INT _ddf_driver_dispatch(
        const   IO_REQ *        pIo_req_map,
                UINT            ioctl,
        const   BUFFER_OBJ *    pBuffer_in,
                BUFFER_OBJ *    pBuffer_out
        );    

        
#ifdef __cplusplus
}
#endif

#endif                
