//--------------------------------------------------------------------------
//Copyright(c) 2009, WenZhong Sun<wanmyqawdr@126.com>
//--------------------------------------------------------------------------
//This file is part of ARMV4T_and_FPGA_based_DSO
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

//--------------------------------------------------------------------------
//--------------------------------------------------------------------------

#ifndef _DFF_CORE_H_
#define _DFF_CORE_H_

#ifdef __cplusplus
extern"C"{
#endif



INT _ddf_request_dispatch(PUINT pArgs);


// *** _ddf_init ***
// -- Description -- 
//  ddf initialize, called once in c_init
// -- Parameters --
// "pDevice", a buffer to contains informations 
// of the device who cause failure.
// -- Return -- 
//  DDF_SUCCSEE, DDF_FAILURE
INT _ddf_init(PDEVICE_OBJ pDevice);



INT _ddf_device_open(
        DEVICE_OBJ *    pDevice,
        UINT            major,
        UINT            minor
        );



INT _ddf_device_close(
        const   DEVICE_OBJ *    pDevice,
                UINT            major,
                UINT            minor
        );



INT _ddf_device_io_control(
                UINT            ioctl,
        const   DEVICE_OBJ *    pDevice,
        const   BUFFER_OBJ *    pBuffer_in,
                BUFFER_OBJ *    pBuffer_out
        );

// *** device_init ***
// -- Description -- 
//  devices initialize, called once in ddf_init
// -- Parameters --
// "pDevice", see note...
// -- Return -- 
//  DDF_SUCCESS, DDF_FAILURE
// -- Note --
//  A buffer which the pDevice pointing to will 
//  be filled with the device_id which caused failure
INT _devices_init(DEVICE_OBJ * pDevice);


VOID enter_sys_mode(VOID);

VOID exit_sys_mode(VOID);


extern DEVICE_OBJ _devices_register[];

#ifdef __cplusplus
}
#endif

#endif