//--------------------------------------------------------------------------
//Copyright(c) 2009, WenZhong Sun<wanmyqawdr@126.com>
//--------------------------------------------------------------------------
//This file is part of ARMV4T_and_FPGA_based_DSO
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

//--------------------------------------------------------------------------
//Device IO Control Codes
//--------------------------------------------------------------------------

#ifndef _IOCTL_H_
#define _IOCTL_H_

#ifdef __cplusplus
extern"C"{
#endif

#define     DDF_DEVICE_OPEN                 0x00000000
#define     DDF_DEVICE_CLOSE                (DDF_DEVICE_OPEN + 1)


//LED
#define     IOCTL_LEDS_ALL_ON               (DDF_DEVICE_CLOSE + 1)
#define     IOCTL_LEDS_ALL_OFF              (IOCTL_LEDS_ALL_ON + 1)
#define     IOCTL_LEDS_ON_OFF               (IOCTL_LEDS_ALL_OFF + 1)



//UART
#define     IOCTL_UART_SEND_CHAR            (IOCTL_LEDS_ON_OFF + 1)
#define     IOCTL_UART_GET_CHAR             (IOCTL_UART_SEND_CHAR + 1)




//CP15
#define     IOCTL_ICACHE_ENABLE             (IOCTL_UART_GET_CHAR + 1)
#define     IOCTL_DCACHE_ENABLE             (IOCTL_ICACHE_ENABLE + 1)
#define     IOCTL_ICACHE_DISABLE            (IOCTL_DCACHE_ENABLE + 1)   
#define     IOCTL_DCACHE_DISABLE            (IOCTL_ICACHE_DISABLE + 1)
#define     IOCTL_ICACHE_FLUSH              (IOCTL_DCACHE_DISABLE + 1)
#define     IOCTL_DCACHE_FLUSH              (IOCTL_ICACHE_FLUSH + 1)
#define     IOCTL_DCACHE_CLEAN              (IOCTL_DCACHE_FLUSH + 1)



//LCD
#define     IOCTL_LCD_BUFFER_OPEN           (IOCTL_DCACHE_CLEAN + 1)
#define     IOCTL_LCD_BUFFER_CLOSE          (IOCTL_LCD_BUFFER_OPEN + 1)
#define     IOCTL_LCD_BUFFER_MODE_SET       (IOCTL_LCD_BUFFER_CLOSE + 1)
#define     IOCTL_LCD_ON_OFF                (IOCTL_LCD_BUFFER_MODE_SET + 1)
#define     IOCTL_LCD_BUFFER_TRIGGER        (IOCTL_LCD_ON_OFF + 1)
#define     IOCTL_LCD_GMEM_GET              (IOCTL_LCD_BUFFER_TRIGGER + 1)



//INTERRUPT
#define     IOCTL_TIMER_INT_ENABLE          (IOCTL_LCD_GMEM_GET + 1)
#define     IOCTL_TIMER_INT_DISABLE         (IOCTL_TIMER_INT_ENABLE + 1)
#define     IOCTL_CPU_IRQ_DISABLE           (IOCTL_TIMER_INT_DISABLE + 1)
#define     IOCTL_CPU_IRQ_ENABLE            (IOCTL_CPU_IRQ_DISABLE + 1)



//TIMER
#define     IOCTL_TIMER_TIME_SET            (IOCTL_CPU_IRQ_ENABLE + 1)
#define     IOCTL_TIMER_ON_OFF              (IOCTL_TIMER_TIME_SET + 1)



//FPGA (Signal Acquisition And Communication Board)
#define     IOCTL_FPGA_SET_SAMPLE_START                 (IOCTL_TIMER_ON_OFF + 1)
#define     IOCTL_FPGA_SET_SAMPLE_STOP                  (IOCTL_FPGA_SET_SAMPLE_START + 1)

#define     IOCTL_FPGA_SET_TRIGGER_ON                   (IOCTL_FPGA_SET_SAMPLE_STOP + 1)
#define     IOCTL_FPGA_SET_TRIGGER_OFF                  (IOCTL_FPGA_SET_TRIGGER_ON + 1)
#define     IOCTL_FPGA_SET_TRIGGER_SRC_CHA              (IOCTL_FPGA_SET_TRIGGER_OFF + 1)
#define     IOCTL_FPGA_SET_TRIGGER_SRC_CHB              (IOCTL_FPGA_SET_TRIGGER_SRC_CHA + 1)
#define     IOCTL_FPGA_SET_TRIGGER_RAISING              (IOCTL_FPGA_SET_TRIGGER_SRC_CHB + 1)
#define     IOCTL_FPGA_SET_TRIGGER_FALLING              (IOCTL_FPGA_SET_TRIGGER_RAISING + 1)
#define     IOCTL_FPGA_GET_TRIGGER_ON_OFF               (IOCTL_FPGA_SET_TRIGGER_FALLING + 1)
#define     IOCTL_FPGA_GET_TRIGGER_RAISING_FALLING      (IOCTL_FPGA_GET_TRIGGER_ON_OFF + 1)
#define     IOCTL_FPGA_GET_TRIGGER_SRC_CHA_CHB          (IOCTL_FPGA_GET_TRIGGER_RAISING_FALLING + 1)

#define     IOCTL_FPGA_SET_ADC_DFS_OFFSET               (IOCTL_FPGA_GET_TRIGGER_SRC_CHA_CHB + 1)
#define     IOCTL_FPGA_SET_ADC_DFS_TWO_COMPLEMENT       (IOCTL_FPGA_SET_ADC_DFS_OFFSET + 1)
#define     IOCTL_FPGA_GET_ADC_DFS                      (IOCTL_FPGA_SET_ADC_DFS_TWO_COMPLEMENT + 1)
#define     IOCTL_FPGA_GET_ADC_IDLE_BUSY                (IOCTL_FPGA_GET_ADC_DFS + 1)

#define     IOCTL_FPGA_SET_SAMPLE_FREQ_AUTO             (IOCTL_FPGA_GET_ADC_IDLE_BUSY + 1)
#define     IOCTL_FPGA_SET_SAMPLE_FREQ_MANUAL           (IOCTL_FPGA_SET_SAMPLE_FREQ_AUTO + 1)
#define     IOCTL_FPGA_SET_SAMPLE_FREQ                  (IOCTL_FPGA_SET_SAMPLE_FREQ_MANUAL + 1)
#define     IOCTL_FPGA_REQ_SIGNAL_FREQ_CALU             (IOCTL_FPGA_SET_SAMPLE_FREQ + 1)
#define     IOCTL_FPGA_GET_SAMPLE_FREQ_AUTO_MANUAL      (IOCTL_FPGA_REQ_SIGNAL_FREQ_CALU + 1)
#define     IOCTL_FPGA_GET_SIGNAL_FREQ_CALU_STATE       (IOCTL_FPGA_GET_SAMPLE_FREQ_AUTO_MANUAL + 1)

#define     IOCTL_FPGA_SET_MEMORY_POOL_PAGE_END_ADDRESS (IOCTL_FPGA_GET_SIGNAL_FREQ_CALU_STATE + 1)
#define     IOCTL_FPGA_GET_MEMORY_POOL_PAGE_END_ADDRESS (IOCTL_FPGA_SET_MEMORY_POOL_PAGE_END_ADDRESS + 1)
#define     IOCTL_FPGA_SET_MEMORY_POOL_END_ADDRESS      (IOCTL_FPGA_GET_MEMORY_POOL_PAGE_END_ADDRESS + 1)
#define     IOCTL_FPGA_GET_MEMORY_POOL_END_ADDRESS      (IOCTL_FPGA_SET_MEMORY_POOL_END_ADDRESS + 1)
#define     IOCTL_FPGA_GET_MEMORY_POOL_EMPTY            (IOCTL_FPGA_GET_MEMORY_POOL_END_ADDRESS + 1)

#define     IOCTL_FPGA_SET_LED                          (IOCTL_FPGA_GET_MEMORY_POOL_EMPTY + 1)
#define     IOCTL_FPGA_GET_LED                          (IOCTL_FPGA_SET_LED + 1)

#define     IOCTL_FPGA_SET_CHA_DC_COUPLE                (IOCTL_FPGA_GET_LED + 1)
#define     IOCTL_FPGA_SET_CHA_AC_COUPLE                (IOCTL_FPGA_SET_CHA_DC_COUPLE + 1)
#define     IOCTL_FPGA_SET_CHA_PRE_ATTENUATOR_TO_X1     (IOCTL_FPGA_SET_CHA_AC_COUPLE + 1)
#define     IOCTL_FPGA_SET_CHA_PRE_ATTENUATOR_TO_X10    (IOCTL_FPGA_SET_CHA_PRE_ATTENUATOR_TO_X1 + 1)
#define     IOCTL_FPGA_SET_CHA_PRE_ATTENUATOR_TO_X100   (IOCTL_FPGA_SET_CHA_PRE_ATTENUATOR_TO_X10 + 1)
#define     IOCTL_FPGA_SET_CHB_DC_COUPLE                (IOCTL_FPGA_SET_CHA_PRE_ATTENUATOR_TO_X100 + 1)
#define     IOCTL_FPGA_SET_CHB_AC_COUPLE                (IOCTL_FPGA_SET_CHB_DC_COUPLE + 1)
#define     IOCTL_FPGA_SET_CHB_PRE_ATTENUATOR_TO_X1     (IOCTL_FPGA_SET_CHB_AC_COUPLE + 1)
#define     IOCTL_FPGA_SET_CHB_PRE_ATTENUATOR_TO_X10    (IOCTL_FPGA_SET_CHB_PRE_ATTENUATOR_TO_X1 + 1)
#define     IOCTL_FPGA_SET_CHB_PRE_ATTENUATOR_TO_X100   (IOCTL_FPGA_SET_CHB_PRE_ATTENUATOR_TO_X10 + 1)

#define     IOCTL_FPGA_SET_CHA_SHIFT_VOLTAGE            (IOCTL_FPGA_SET_CHB_PRE_ATTENUATOR_TO_X100 + 1)
#define     IOCTL_FPGA_SET_CHA_TRIGGER_VOLTAGE          (IOCTL_FPGA_SET_CHA_SHIFT_VOLTAGE + 1)
#define     IOCTL_FPGA_SET_CHA_VGA_GAIN                 (IOCTL_FPGA_SET_CHA_TRIGGER_VOLTAGE + 1)
   
#define     IOCTL_FPGA_SET_CHB_SHIFT_VOLTAGE            (IOCTL_FPGA_SET_CHA_VGA_GAIN + 1)
#define     IOCTL_FPGA_SET_CHB_TRIGGER_VOLTAGE          (IOCTL_FPGA_SET_CHB_SHIFT_VOLTAGE + 1)
#define     IOCTL_FPGA_SET_CHB_VGA_GAIN                 (IOCTL_FPGA_SET_CHB_TRIGGER_VOLTAGE + 1)

#define     IOCTL_FPGA_GET_CHA_COUPLE                   (IOCTL_FPGA_SET_CHB_VGA_GAIN + 1)
#define     IOCTL_FPGA_GET_CHA_PRE_ATTENUATOR           (IOCTL_FPGA_GET_CHA_COUPLE + 1)
#define     IOCTL_FPGA_GET_CHB_COUPLE                   (IOCTL_FPGA_GET_CHA_PRE_ATTENUATOR + 1)
#define     IOCTL_FPGA_GET_CHB_PRE_ATTENUATOR           (IOCTL_FPGA_GET_CHB_COUPLE + 1)

#define     IOCTL_FPGA_GET_CHA_SHIFT_VOLTAGE            (IOCTL_FPGA_GET_CHB_PRE_ATTENUATOR + 1)
#define     IOCTL_FPGA_GET_CHA_TRIGGER_VOLTAGE          (IOCTL_FPGA_GET_CHA_SHIFT_VOLTAGE + 1)
#define     IOCTL_FPGA_GET_CHA_VGA_GAIN                 (IOCTL_FPGA_GET_CHA_TRIGGER_VOLTAGE + 1)

#define     IOCTL_FPGA_GET_CHB_SHIFT_VOLTAGE            (IOCTL_FPGA_GET_CHA_VGA_GAIN + 1)
#define     IOCTL_FPGA_GET_CHB_TRIGGER_VOLTAGE          (IOCTL_FPGA_GET_CHB_SHIFT_VOLTAGE + 1)
#define     IOCTL_FPGA_GET_CHB_VGA_GAIN                 (IOCTL_FPGA_GET_CHB_TRIGGER_VOLTAGE + 1)

#define     IOCTL_FPGA_GET_SINGAL_FREQ_CALU_COUNTER     (IOCTL_FPGA_GET_CHB_VGA_GAIN + 1)
#define     IOCTL_FPGA_GET_SRAM_EMPTY                   (IOCTL_FPGA_GET_SINGAL_FREQ_CALU_COUNTER + 1)

#define     IOCTL_FPGA_ENABLE_DMA_SERVICE               (IOCTL_FPGA_GET_SRAM_EMPTY + 1)
#define     IOCTL_FPGA_DISABLE_DMA_SERVICE              (IOCTL_FPGA_ENABLE_DMA_SERVICE + 1)

#define     IOCTL_FPGA_ENABLE_INT_SRAM_FULL             (IOCTL_FPGA_GET_SRAM_EMPTY + 1)
#define     IOCTL_FPGA_DISABLE_INT_SRAM_FULL            (IOCTL_FPGA_ENABLE_INT_SRAM_FULL + 1)

#define     IOCTL_FPGA_ENABLE_INT_HC595_DONE            (IOCTL_FPGA_DISABLE_INT_SRAM_FULL + 1)
#define     IOCTL_FPGA_DISABLE_INT_HC595_DONE           (IOCTL_FPGA_ENABLE_INT_HC595_DONE + 1)

#define     IOCTL_FPGA_ENABLE_INT_TLV5631_DONE          (IOCTL_FPGA_DISABLE_INT_HC595_DONE + 1)
#define     IOCTL_FPGA_DISABLE_INT_TLV5631_DONE         (IOCTL_FPGA_ENABLE_INT_TLV5631_DONE + 1)

#define     IOCTL_FPGA_ENABLE_INT_ARM_SELECTED          (IOCTL_FPGA_DISABLE_INT_TLV5631_DONE + 1)
#define     IOCTL_FPGA_DISABLE_INT_ARM_SELECTED         (IOCTL_FPGA_ENABLE_INT_ARM_SELECTED + 1)

#define     IOCTL_FPGA_ENABLE_INT_HOST_SELECTED         (IOCTL_FPGA_DISABLE_INT_ARM_SELECTED + 1)
#define     IOCTL_FPGA_DISABLE_INT_HOST_SELECTED        (IOCTL_FPGA_ENABLE_INT_HOST_SELECTED + 1)

#define     IOCTL_FPGA_ENABLE_INT_FREQ_DONE             (IOCTL_FPGA_DISABLE_INT_HOST_SELECTED + 1)
#define     IOCTL_FPGA_DISABLE_INT_FREQ_DONE            (IOCTL_FPGA_ENABLE_INT_FREQ_DONE + 1)

#define     IOCTL_FPGA_ENABLE_INT_FREQ_OUT_OF_RANGE     (IOCTL_FPGA_DISABLE_INT_FREQ_DONE + 1)
#define     IOCTL_FPGA_DISABLE_INT_FREQ_OUT_OF_RANGE    (IOCTL_FPGA_ENABLE_INT_FREQ_OUT_OF_RANGE + 1)

#define     IOCTL_FPGA_ENABLE_INT_WRITE_EP_DONE         (IOCTL_FPGA_DISABLE_INT_FREQ_OUT_OF_RANGE + 1)
#define     IOCTL_FPGA_DISABLE_INT_WRITE_EP_DONE        (IOCTL_FPGA_ENABLE_INT_WRITE_EP_DONE + 1)

#define     IOCTL_FPGA_GET_SRCS_PENDING                 (IOCTL_FPGA_DISABLE_INT_WRITE_EP_DONE + 1)

#define     IOCTL_FPGA_CLR_SRCS_SRAM_FULL               (IOCTL_FPGA_GET_SRCS_PENDING + 1)
#define     IOCTL_FPGA_CLR_SRCS_HC595_DONE              (IOCTL_FPGA_CLR_SRCS_SRAM_FULL + 1)
#define     IOCTL_FPGA_CLR_SRCS_TLV5631_DONE            (IOCTL_FPGA_CLR_SRCS_HC595_DONE + 1)
#define     IOCTL_FPGA_CLR_SRCS_FREQ_DONE               (IOCTL_FPGA_CLR_SRCS_TLV5631_DONE + 1)
#define     IOCTL_FPGA_CLR_SRCS_FREQ_OUT_OF_RANGE       (IOCTL_FPGA_CLR_SRCS_FREQ_DONE + 1)

#define     IOCTL_FPGA_GET_POOL_DATA                    (IOCTL_FPGA_CLR_SRCS_FREQ_OUT_OF_RANGE + 1)

#define     IOCTL_FPGA_SET_HOST_ARM_SELECT              (IOCTL_FPGA_GET_POOL_DATA + 1)
#define     IOCTL_FPGA_GET_HOST_ARM_SELECT              (IOCTL_FPGA_SET_HOST_ARM_SELECT + 1)

#ifdef __cplusplus
}
#endif

#endif
