//--------------------------------------------------------------------------
//Copyright(c) 2009, WenZhong Sun<wanmyqawdr@126.com>
//--------------------------------------------------------------------------
//This file is part of ARMV4T_and_FPGA_based_DSO
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

//--------------------------------------------------------------------------
// 
//--------------------------------------------------------------------------
#include <math.h>
#include <stdlib.h>
#include "../../inc/typedef.h"
#include "../../inc/driver.h"
#include "./draw_lib.h"

static DEVICE_OBJ draw_device;

UINT (*_gmem)[240];

pfn_PUT_PIXEL _put_pixel = _internal_put_pixel;

//initialize draw_lib
void _draw_lib_init()
{
    //open graphic device
    ddf_DeviceOpen(&draw_device, LCD, 0);
    //set single buffer mode
    
    ddf_DeviceIoControl(IOCTL_LCD_BUFFER_MODE_SET, &draw_device, (PBUFFER_OBJ)2, 0);
    //open graphic buffer
    ddf_DeviceIoControl(IOCTL_LCD_BUFFER_OPEN, &draw_device, 0, (PBUFFER_OBJ)&_gmem);
    //set graphic device ON
    ddf_DeviceIoControl(IOCTL_LCD_ON_OFF, &draw_device, (PBUFFER_OBJ)1, 0);
}

void _internal_put_pixel(INT x_pos, INT y_pos, UINT color)
{
    _gmem[y_pos][x_pos] = color;
}


void _line(INT x1, INT y1, INT x2, INT y2, UINT color)
{
	INT dx, dy, e;
	dx = x2 - x1; 
	dy = y2 - y1;
    
	if(dx >= 0){
		if(dy >= 0){
			if(dx >= dy){
				e = dy - dx / 2;
				while(x1 <= x2){
					_put_pixel(x1, y1, color);
					if(e > 0){ 
					    y1 += 1;
					    e -= dx;
					}	
					x1 += 1;
					e += dy;
				}
			}else{
				e = dx - dy / 2;
				while(y1 <= y2){
					_put_pixel(x1, y1, color);
					if(e>0){
					    x1 += 1;
					    e -= dy;
					}	
					y1 += 1;
					e += dx;
				}
			}
		}else{
			dy =- dy; 
			if(dx >= dy){
				e = dy - dx / 2;
				while(x1<=x2){
					_put_pixel(x1, y1, color);
					if(e > 0){ 
					    y1 -= 1;
					    e -= dx;
					}	
					x1 += 1;
					e += dy;
				}
			}else{
				e = dx - dy / 2;
				while(y1 >= y2){
					_put_pixel(x1, y1, color);
					if(e>0){
					    x1 += 1;
					    e -= dy;
					}	
					y1 -= 1;
					e += dx;
				}
			}
		}	
	}else{
		dx = -dx;		
		if(dy >= 0){
			if(dx>=dy){
				e = dy - dx / 2;
				while(x1 >= x2){
					_put_pixel(x1, y1, color);
					if(e>0){
					    y1 += 1;
					    e -= dx;
					}	
					x1 -= 1;
					e += dy;
				}
			}else{
				e = dx - dy / 2;
				while(y1 <= y2){
					_put_pixel(x1, y1, color);
					if(e > 0){
					    x1 -= 1;
					    e -= dy;
					}	
					y1 += 1;
					e += dx;
				}
			}
		}else{
			dy =- dy;  
			if(dx >= dy){
				e = dy - dx / 2;
				while(x1>=x2){
					_put_pixel(x1, y1, color);
					if(e>0){
					    y1 -= 1;
					    e -= dx;
					}	
					x1 -= 1;
					e += dy;
				}
			}else{
				e = dx - dy / 2;
				while(y1 >= y2){
					_put_pixel(x1, y1, color);
					if(e > 0){
					    x1 -= 1;
					    e -= dy;
					}	
					y1 -= 1;
					e += dx;
				}
			}
		}	
	}
}

void _rectangle(const RECT * prect, UINT color)
{
    _line(prect->left, prect->top, prect->right, prect->top, color);
    _line(prect->right, prect->top, prect->right, prect->bottom, color);
    _line(prect->right, prect->bottom, prect->left, prect->bottom, color);
    _line(prect->left, prect->bottom, prect->left, prect->top, color);
}

void _filled_rectangle(const RECT * prect, UINT color)
{
    INT y;
    for(y = prect->top; y <= prect->bottom; y++)
        _line(prect->left, y, prect->right, y, color);
}

void _buffer_mode_set(UINT mode)
{
    
}

void _pen_set(const PEN * ppen)
{

}

void _release_draw_lib(void)
{

}

void _draw_buffer_trigger(void)
{
    ddf_DeviceIoControl(
        IOCTL_LCD_BUFFER_TRIGGER, 
        &draw_device, 
        0, 
        (PBUFFER_OBJ)&_gmem);     
}



