//--------------------------------------------------------------------------
//Copyright(c) 2009, WenZhong Sun<wanmyqawdr@126.com>
//--------------------------------------------------------------------------
//This file is part of ARMV4T_and_FPGA_based_DSO
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

//--------------------------------------------------------------------------
// 
//--------------------------------------------------------------------------

#ifndef _DRAW_LIB_H_
#define _DRAW_LIB_H_

#ifdef __cplusplus
extern"C"{
#endif

//screen horizontal size and vertical size
#define     X_SIZE      240
#define     Y_SIZE      320

#define     RGB(rr, gg, bb)  (((rr) << 16) | ((gg) << 8) | (bb))

//basic colors
#define     BLUE            RGB(0x00, 0x00, 0xff)
#define     GREEN           RGB(0x00, 0xff, 0x00)
#define     RED             RGB(0xff, 0x00, 0x00)
#define     CYAN            RGB(0x00, 0xff, 0xff)
#define     MAGENTA         RGB(0xff, 0x00, 0xff)
#define     YELLOW          RGB(0xff, 0xff, 0x00)
#define     LIGHTBLUE       RGB(0x80, 0x80, 0xff)
#define     LIGHTGREEN      RGB(0x80, 0xff, 0x80)
#define     LIGHTRED        RGB(0xff, 0x80, 0x80)
#define     LIGHTCYAN       RGB(0x80, 0xff, 0xff)
#define     LIGHTMAGENTA    RGB(0xff, 0x80, 0xff)
#define     LIGHTYELLOW     RGB(0xff, 0xff, 0x80)
#define     DARKBLUE        RGB(0x00, 0x00, 0x80)
#define     DARKGREEN       RGB(0x00, 0x80, 0x00)
#define     DARKRED         RGB(0x80, 0x00, 0x00)
#define     DARKCYAN        RGB(0x00, 0x80, 0x80)
#define     DARKMAGENTA     RGB(0x80, 0x00, 0x80)
#define     DARKYELLOW      RGB(0x80, 0x80, 0x00)
#define     WHITE           RGB(0xff, 0xff, 0xff)
#define     LIGHTGRAY       RGB(0xd3, 0xd3, 0xd3)
#define     GRAY            RGB(0x80, 0x80, 0x80)
#define     DARKGRAY        RGB(0x40, 0x40, 0x40)
#define     BLACK           RGB(0x00, 0x00, 0x00)
#define     BROWN           RGB(0xa5, 0x2a, 0x2a)

//line types

//types definitions
typedef struct _rect{
    INT left;
    INT top;
    INT right;
    INT bottom;
}RECT, *PRECT;

typedef struct _pen{
    INT width;
    INT type;
    INT color;
}PEN, *PPEN;

typedef VOID (*pfn_PUT_PIXEL)(INT, INT, UINT);

extern pfn_PUT_PIXEL _put_pixel;

extern UINT (*_gmem)[240];

void _draw_lib_init(void);

void _release_draw_lib(void);

void _line(INT x1, INT y1, INT x2, INT y2, UINT color);

void _rectangle(const RECT * prect, UINT color);

void _filled_rectangle(const RECT * prect, UINT color);

void _buffer_mode_set(UINT mode);

void _internal_put_pixel(INT x_pos, INT y_pos, UINT color);

void _pen_set(const PEN * ppen);

void _draw_buffer_trigger(void);

#ifdef __cplusplus
}
#endif

#endif