//--------------------------------------------------------------------------
//Copyright(c) 2009, WenZhong Sun<wanmyqawdr@126.com>
//--------------------------------------------------------------------------
//This file is part of ARMV4T_and_FPGA_based_DSO
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

//--------------------------------------------------------------------------
// 
//--------------------------------------------------------------------------

#ifndef _FONT_LIB_
#define _FONT_LIB_

#ifdef __cplusplus
extern"C"{
#endif

#define LCD_PRINT_BUFFER_LENGTH_MAX     256

typedef struct _font{
    CHAR font_name[20];
    const UINT * pchar_map;
    UINT char_height;
    UINT char_width;
    UINT char_size;
}FONT, *PFONT;

typedef struct _text_print_style{
    UINT is_set_back_color;
    UINT back_color;
    UINT front_color;
    UINT space;
    UINT orientation;
    UINT underline_type;
    UINT underline_width;
}TEXT_PRINT_STYLE, *PTEXT_PRINT_STYLE;

typedef struct _text_class{
    const struct _font * pascii_font;
    const struct _font * pchinese_font;
          struct _text_print_style * ptext_print_style;
}TEXT_CLASS, *PTEXT_CLASS;

void _lcd_printf(
            INT                x_pos, 
            INT                y_pos,
    const   TEXT_CLASS        * ptext_class,     
    const   CHAR              * fmt,
            ...
    );

void _lcd_put_char_ascii(
            PINT               px_pos, 
            PINT               py_pos, 
    const   TEXT_CLASS        * ptext_class,
    const   CHAR              * pchar
    );
    
void _lcd_put_char_chinese(
            PINT               px_pos,
            PINT               py_pos,
    const   TEXT_CLASS        * ptext_class,
    const   CHAR              * pchar
    );

void lcd_printf(
            INT                x_pos,
            INT                y_pos,
    const   CHAR              * fmt,
            ...
            );

void _font_lib_init(void);

void _font_lib_shut_down(void);

PTEXT_CLASS _sys_text_class_get(void);

const TEXT_CLASS * _font_set(UINT size_pt, const CHAR *name);

UINT _char_horizontal_space_set(UINT space_pt);

void _char_back_color_disable(void);

void _char_back_color_enable(void);

UINT _char_front_color_set(UINT fornt_color);

UINT _char_back_color_set(UINT back_color);

extern const FONT _fonts_register[];
    
#ifdef __cplusplus
}
#endif

#endif