//--------------------------------------------------------------------------
//Copyright(c) 2009, WenZhong Sun<wanmyqawdr@126.com>
//--------------------------------------------------------------------------
//This file is part of ARMV4T_and_FPGA_based_DSO
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

//--------------------------------------------------------------------------
// 
//--------------------------------------------------------------------------

#ifndef _WINDOWS_H_
#define _WINDOWS_H_

#ifdef __cplusplus
extern"C"{
#endif

#define WIN_MANAGER_STACK_LENGTH    (1024 * 1)

#define CHILD_WINDOWS_MAX       256
#define WINDOW_TITLE_LENGTH     256

// -- Structure --
// "_window_object", alias "WIN_OBJ", pointer "PWIN_OBJ"
// -- Description --
// window abstract
// -- Members --
// 1)   "pparent_window", point to parent window of current window
// 2)   "child_windows",  point to child windows of current window
// 3)   "ptext_print_style",  text print style of current window
// 4, 5)"left, top",         location point of current window
// 6)   "title",         title string of current window
// 7)   "window_proc", point to window procedure of current window
typedef struct _window_object{
    PTEXT_PRINT_STYLE ptext_print_style;
    UINT back_color;
    UINT left;
    UINT top;
    CHAR title[WINDOW_TITLE_LENGTH];
    UINT (*win_proc)(
            struct _window_object * win_obj, 
            UINT msg, 
            PUINT wparam, 
            PUINT lparam
            );    
    struct _window_object * pparent_window;
    struct _window_object * child_windows[CHILD_WINDOWS_MAX];
}WIN_OBJ, *PWIN_OBJ;

UINT _win_manager_init(VOID);

UINT _win_manager(PVOID arg);

#ifdef __cplusplus
}
#endif

#endif