//--------------------------------------------------------------------------
//Copyright(c) 2009, WenZhong Sun<wanmyqawdr@126.com>
//--------------------------------------------------------------------------
//This file is part of ARMV4T_and_FPGA_based_DSO
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

//--------------------------------------------------------------------------
//--------------------------------------------------------------------------

#ifndef _INTERRUPT_H_

#ifdef __cplusplus
extern"C"{
#endif

#define _INTS_HANDLE_METHOD 2

typedef UINT (*IRQ_HANDLER)(void *param);

//kernel tick for switch context
UINT kernel_tick(void *param);

//General interrupts
UINT adc_handler(void *param);

UINT rtc_handler(void *param);

UINT spi0_handler(void *param);
UINT spi1_handler(void *param);

UINT uart0_handler(void *param);
UINT uart1_handler(void *param);
UINT uart2_handler(void *param);

UINT iic_handler(void *param);

UINT usbh_handler(void *param);
UINT usbd_handler(void *param);

UINT nfcon_handler(void *param);

UINT sdi_handler(void *param);

UINT dma3_handler(void *param);
UINT dma2_handler(void *param);
UINT dma1_handler(void *param);
UINT dma0_handler(void *param);

UINT lcd_handler(void *param);

UINT timer3_handler(void *param);
UINT timer2_handler(void *param);
UINT timer1_handler(void *param);
UINT timer0_handler(void *param);

UINT wdt_ac97_handler(void *param);

UINT rtc_tick_handler(void *param);

UINT cam_handler(void *param);

UINT nbatt_flt_handler(void *param);

UINT eint8_23_handler(void *param);
UINT eint4_7_handler(void *param);
UINT eint3_handler(void *param);
UINT eint2_handler(void *param);
UINT eint1_handler(void *param);
UINT eint0_handler(void *param);

#ifdef __cplusplus
}
#endif

#endif