//--------------------------------------------------------------------------
//Copyright(c) 2009, WenZhong Sun<wanmyqawdr@126.com>
//--------------------------------------------------------------------------
//This file is part of ARMV4T_and_FPGA_based_DSO
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

//--------------------------------------------------------------------------
//--------------------------------------------------------------------------
#include "../inc/typedef.h"
#include "./interrupt.h"
#include "./service/service.h"
#include "../mini2440/target/S3C2440_regs.h"

static INT_REG * const int_reg = (PINT_REG)0x4a000000;

UINT kernel_tick(void *param);

#if(_INTS_HANDLE_METHOD == 1)
    //Method 1.
    static IRQ_HANDLER _irq_handlers_register[] = {
        eint0_handler,          eint1_handler,
        eint2_handler,          eint3_handler,
        eint4_7_handler,        eint8_23_handler,
        cam_handler,            nbatt_flt_handler,
        rtc_tick_handler,       wdt_ac97_handler,
        timer0_handler,         timer1_handler,
        timer2_handler,         timer3_handler,
(IRQ_HANDLER)kernel_tick,       uart2_handler,
        lcd_handler,            dma0_handler,
        dma1_handler,           dma2_handler,
        dma3_handler,           sdi_handler,
        spi0_handler,           uart1_handler,
        nfcon_handler,          usbd_handler,
        usbh_handler,           iic_handler,
        uart0_handler,          spi1_handler,
        rtc_handler,            adc_handler
    };
#else   
    //Method 2.  
    static IRQ_HANDLER _irq_handlers_register[] = {
        ints_service_handler,       ints_service_handler,
        ints_service_handler,       ints_service_handler,
        ints_service_handler,       ints_service_handler,
        ints_service_handler,       ints_service_handler,
        ints_service_handler,       ints_service_handler,
        ints_service_handler,       ints_service_handler,
        ints_service_handler,       ints_service_handler,
    (IRQ_HANDLER)kernel_tick,       ints_service_handler,
        ints_service_handler,       ints_service_handler,
        ints_service_handler,       ints_service_handler,
        ints_service_handler,       ints_service_handler,
        ints_service_handler,       ints_service_handler,
        ints_service_handler,       ints_service_handler,
        ints_service_handler,       ints_service_handler,
        ints_service_handler,       ints_service_handler,
        ints_service_handler,       ints_service_handler,
    };
#endif

__irq void system_IRQ_handler(void)
{
    _irq_handlers_register[int_reg->INTOFFSET](int_reg);
}