//--------------------------------------------------------------------------
//Copyright(c) 2009, WenZhong Sun<wanmyqawdr@126.com>
//--------------------------------------------------------------------------
//This file is part of ARMV4T_and_FPGA_based_DSO
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

//---------------------------------------------------------------------------
//header for DSO_DEMO
//---------------------------------------------------------------------------

#include "../../../../inc/typedef.h"
#include "../../../../inc/driver.h"
#include "../../../../inc/gui.h"
#include "../../../../inc/task.h"
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "./fpga_lib.h"

#define SAMPLE_SIZE 230

UINT sample_buf[SAMPLE_SIZE];
UINT buf_cha[SAMPLE_SIZE];
UINT buf_chb[SAMPLE_SIZE];

VOID user_defined_put_pixel(INT x, INT y, UINT color)
{
    //transform coordinate to fit the orientation of screen
    
    if(x >= Y_SIZE || y >= X_SIZE)
        return;
    
    _gmem[x][X_SIZE - 1 - y] = color;
}

VOID draw_background(VOID)
{
    INT x_pos, y_pos;
    
    RECT rect = {0, 0, 319, 239};
    _filled_rectangle(&rect, WHITE);
    
    rect.right = 229;
    rect.bottom = 199;
    _filled_rectangle(&rect, DARKBLUE);
    
    for(y_pos = 19; y_pos < 199; y_pos += 20)
        _line(0, y_pos, 230, y_pos, DARKCYAN);
    
    for(x_pos = 22; x_pos < 229; x_pos += 23)
        _line(x_pos, 0, x_pos, 199, DARKCYAN);
        
    rect.right = 230;
    rect.bottom = 200;
    _rectangle(&rect, LIGHTGREEN);
    
    rect.left = 231;
    rect.top = 0;
    rect.right = 319;
    rect.bottom = 199;
    _filled_rectangle(&rect, DARKMAGENTA);
    
    rect.left = 0;
    rect.top = 201;
    rect.right = 319;
    rect.bottom = 239;
    _filled_rectangle(&rect, GRAY);
    
    _font_set(16, NULL);
    _char_front_color_set(LIGHTCYAN);
    _lcd_printf(
            20, 
            205, 
            _sys_text_class_get(), 
            "źŲʾ"
        );
        
    _font_set(12, NULL);
    
    _lcd_printf(
        215, 
        210, 
        _sys_text_class_get(), 
        "ƣ"
    );
    
    _lcd_printf(
        215, 
        225, 
        _sys_text_class_get(), 
        "      2010.7"
    );
    
    _char_front_color_set(GREEN);
    _lcd_printf(
        232,
        1,
        _sys_text_class_get(),
        "ٶ:100M"
    );
    
    _lcd_printf(
        232,
        13,
        _sys_text_class_get(),
        ":230PT"
    );
    
    _lcd_printf(
        232,
        25,
        _sys_text_class_get(),
        ":"
    );
    
    _lcd_printf(
        232,
        37,
        _sys_text_class_get(),
        "Զ:"
    );

    _lcd_printf(
        232,
        49,
        _sys_text_class_get(),
        "Ƶʲ:"
    );
    
    _lcd_printf(
        232,
        61,
        _sys_text_class_get(),
        "ѹ˥:X10"
    );
    
    _lcd_printf(
        232,
        73,
        _sys_text_class_get(),
        "м:1"
    );
    
    _lcd_printf(
        232,
        85,
        _sys_text_class_get(),
        "źλ:0mv"
    );
    
    _lcd_printf(
        232,
        97,
        _sys_text_class_get(),
        ":Ͽ"
    );
    

    _lcd_printf(
        232,
        121,
        _sys_text_class_get(),
        "ͨ A:"
    );
    _line(280, 126, 310, 126, RED);
    _line(280, 127, 310, 127, RED);
    
    _lcd_printf(
        232,
        133,
        _sys_text_class_get(),
        ":1V/div"
    );
    
    _lcd_printf(
        232,
        145,
        _sys_text_class_get(),
        "ʱ:100ns/div"
    );
    
    _lcd_printf(
        232,
        161,
        _sys_text_class_get(),
        "ͨ B:"
    );
    _line(280, 166, 310, 166, YELLOW);    
    _line(280, 167, 310, 167, YELLOW);
    
    _lcd_printf(
        232,
        173,
        _sys_text_class_get(),
        ":1V/div"
    );
    
    _lcd_printf(
        232,
        185,
        _sys_text_class_get(),
        "ʱ:100ns/div"
    );
}

VOID draw_signal(VOID)
{
    INT x_pos;
    /*for(x_pos = 0; x_pos < SAMPLE_SIZE - 1; x_pos++)
        printf("%x\n", sample_buf[x_pos]);*/
    
    
    for(x_pos = 0; x_pos < SAMPLE_SIZE - 1; x_pos++){
        _line(
                x_pos, 
                99 + buf_cha[x_pos] - 100, 
                x_pos + 1,
                99 + buf_cha[x_pos + 1] - 100,
                RED
              );
              
        _line(
                x_pos, 
                99 + buf_chb[x_pos] - 100, 
                x_pos + 1,
                99 + buf_chb[x_pos + 1] - 100,
                YELLOW
              );
    }
    
    _draw_buffer_trigger();
}

VOID get_signal_data(VOID)
{
    sample_start();
    
    while(!is_adc_idle)
        continue;
    
    get_pool_data(sample_buf, SAMPLE_SIZE);
}

VOID init(VOID)
{
    init_fpga_lib();

    host_bus_select(FLASE);
    
    set_pool_end_addr(SAMPLE_SIZE - 1);
    
    set_pre_attenuator(PRE_ATTENUATOR_X10, CHA);
    set_pre_attenuator(PRE_ATTENUATOR_X10, CHB);
    
    _put_pixel = user_defined_put_pixel; 
}

VOID delay(VOID)
{
    UINT t = 0x3fffff;
    while(t--)
        continue;
}

VOID pre_process_signal_data(VOID)
{
    UINT index;
    for(index = 0; index < SAMPLE_SIZE; index++){
        buf_cha[index] = (sample_buf[index] & 0xff) * (DOUBLE)0.78125;
        buf_chb[index] = ((sample_buf[index] >> 8) & 0xff) * (DOUBLE)0.78125;
    }
    
}

INT dso_demo(VOID)
{
    init();
    
    while(TRUE)
    {
        draw_background();
        get_signal_data();
        pre_process_signal_data();
        draw_signal();
        delay();
    }
    
    return 0;
}


