//--------------------------------------------------------------------------
//Copyright(c) 2009, WenZhong Sun<wanmyqawdr@126.com>
//--------------------------------------------------------------------------
//This file is part of ARMV4T_and_FPGA_based_DSO
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

//---------------------------------------------------------------------------
//---------------------------------------------------------------------------

#ifndef _FPGA_LIB_H_
#define _FPGA_LIB_H_

#ifdef __cplusplus
extern"C"{
#endif

#define CHA                     1
#define CHB                     0

#define ADC_FMT_OFFSET          0
#define ADC_FMT_TWO_COMPLEMENT  1

#define TRIG_SRC_CHA            1
#define TRIG_SRC_CHB            0

#define TRIG_TYPE_RAISING       1
#define TRIG_TYPE_FALLING       0

#define TRIG_ON                 1
#define TRIG_OFF                0

#define PRE_ATTENUATOR_X1       0
#define PRE_ATTENUATOR_X10      1
#define PRE_ATTENUATOR_X100     2

#define DC_COUPLE               0
#define AC_COUPLE               1

#define HOST                    1
#define ARM                     0

INT init_fpga_lib(VOID);

INT up_trigger(INT volt_detal, INT ch);
INT set_trigger(INT volt, INT ch);
INT get_trigger(INT ch);

INT up_shifter(INT volt_detal, INT ch);
INT set_shifter(INT volt_detal, INT ch);
INT get_shifter(INT ch);

INT up_gain(INT gain_detal, INT ch);
INT set_gain(INT gain, INT ch);
INT get_gain(INT ch);

INT set_pre_attenuator(INT attenuator, INT ch);
INT get_pre_attenuator(INT ch);

INT set_couple(INT DC_AC, INT ch);
INT get_couple(INT ch);

BOOL is_arm_bus_select(VOID);
INT host_bus_select(BOOL host_sel);

INT sample_start(VOID);
INT sample_stop(VOID);

BOOL is_adc_idle(VOID);
BOOL is_pool_empty(VOID);

INT set_page_end_addr(UINT addr);
INT get_page_end_addr(VOID);

INT set_pool_end_addr(UINT addr);
INT get_pool_end_addr(VOID);

INT light_leds(UINT leds);

INT get_pool_data(PUINT pbuf, UINT size);

INT get_srcs_pending(VOID);

#ifdef __cpluscplus
}
#endif

#endif
