//--------------------------------------------------------------------------
//Copyright(c) 2009, WenZhong Sun<wanmyqawdr@126.com>
//--------------------------------------------------------------------------
//This file is part of ARMV4T_and_FPGA_based_DSO
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

//--------------------------------------------------------------------------
// driver for cp15
//--------------------------------------------------------------------------
#include "../../../inc/typedef.h"
#include "../../../inc/ddf_api.h"
#include "../target/cp15.h"
#include "./co_processor15.h"

BEGIN_IO_REQUEST_MAP(io_request_map)
    IOCTL_ROUTINE(IOCTL_ICACHE_ENABLE, ICache_enable)
    IOCTL_ROUTINE(IOCTL_DCACHE_ENABLE, DCache_enable)
    IOCTL_ROUTINE(IOCTL_ICACHE_DISABLE, ICache_disable)
    IOCTL_ROUTINE(IOCTL_DCACHE_DISABLE, DCache_disable)
    IOCTL_ROUTINE(IOCTL_ICACHE_FLUSH, ICache_flush)
    IOCTL_ROUTINE(IOCTL_DCACHE_FLUSH, DCache_flush)
    IOCTL_ROUTINE(IOCTL_DCACHE_CLEAN, DCache_clean)
END_IO_REQUEST_MAP()

INT co_processor15_init(void)
{
    _mmu_init();
    return DDF_SUCCESS;
}

UID co_processor15_open(UINT major, UINT minor)
{
    return DDF_SUCCESS;
}

INT co_processor15_close(UINT major, UINT minor)
{
    return DDF_SUCCESS;
}

INT co_processor15_driver_entry(
            UINT ioctl, 
    const   BUFFER_OBJ * pbuffer_in, 
            BUFFER_OBJ * pbuffer_out
    )
{
     return _ddf_driver_dispatch(
                io_request_map, 
                ioctl, 
                pbuffer_in, 
                pbuffer_out
                );   
}

INT ICache_disable(
    const   BUFFER_OBJ * pbuffer_in,
            BUFFER_OBJ * pbuffer_out
    )
{
    _cp15_ICache_disable();
    return DDF_SUCCESS;
}               

INT DCache_disable(
    const   BUFFER_OBJ * pbuffer_in,
            BUFFER_OBJ * pbuffer_out
    )
{
    _cp15_DCache_disable();
    return DDF_SUCCESS;
}

INT ICache_enable(
    const   BUFFER_OBJ * pbuffer_in,
            BUFFER_OBJ * pbuffer_out
    )
{
    _cp15_ICache_enable();
    return DDF_SUCCESS;
}

INT DCache_enable(
    const   BUFFER_OBJ * pbuffer_in,
            BUFFER_OBJ * pbuffer_out
    )
{
    _cp15_DCache_enable();
    return  DDF_SUCCESS;
}

INT ICache_flush(
    const   BUFFER_OBJ * pbuffer_in,
            BUFFER_OBJ * pbuffer_out
    )
{
    _cp15_ICache_flush();
    return DDF_SUCCESS;
}

INT DCache_flush(
    const   BUFFER_OBJ * pbuffer_in,
            BUFFER_OBJ * pbuffer_out
    )
{
    _cp15_DCache_flush();
    return DDF_SUCCESS;
}

INT DCache_clean(
    const   BUFFER_OBJ * pbuffer_in,
            BUFFER_OBJ * pbuffer_out
    )
{
    _cp15_DCache_clean();
    return DDF_SUCCESS;
}