//--------------------------------------------------------------------------
//Copyright(c) 2009, WenZhong Sun<wanmyqawdr@126.com>
//--------------------------------------------------------------------------
//This file is part of ARMV4T_and_FPGA_based_DSO
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
/////////////////////////////////////////////////////////////////////////////
#include "../../inc/typedef.h"
#include "../ddf/ddf_type.h"
#include "./device_id.h"
/////////////////////////////////////////////////////////////////////////////

//add or remove your device driver below

#include "./leds.h"
#include "./uart.h"
#include "./co_processor15.h"
#include "./lcd.h"
#include "./buttons.h"
#include "./fpga.h"
#include "./dma.h"
#include "./usb.h"
#include "./touch_panel.h"
#include "./timers.h"
#include "./ints_ctrl.h"

//devices will be initialized by the order as which are in the _devices_register

DEVICE_OBJ _devices_register[] = {       
 
    {   
        "MINI2440_CP15",
        CO_PROCESSOR15,
        co_processor15_init,
        co_processor15_open,
        co_processor15_close,
        co_processor15_driver_entry
    },
    
    {
        "MINI2440_UART",
        UART,
        uart_init,
        uart_open,
        uart_close,
        uart_driver_entry
    },
    
    {
        "MINI2440_LEDs", 
        LEDs, 
        leds_init, 
        leds_open, 
        leds_close, 
        leds_driver_entry
    },
    
    {
        "MINI2440_LCD",
        LCD,
        lcd_init,
        lcd_open,
        lcd_close,
        lcd_driver_entry
    },
    
    {
        "MINI2440_TOUCH",
        TOUCH,
        touch_panel_init,
        touch_panel_open,
        touch_panel_close,
        touch_panel_driver_entry
    },
    
    {
        "MINI2440_USB",
        USB,
        usb_init,
        usb_open,
        usb_close,
        usb_driver_entry
    },
    
    {
        "MINI2440_BTNs",
        BUTTONs,
        buttons_init,
        buttons_open,
        buttons_close,
        buttons_driver_entry
    },
    
    {
        "MINI2440_FPGA",
        FPGA,
        fpga_init,
        fpga_open,
        fpga_close,
        fpga_driver_entry
    },
    
    {
        "MINI2440_DMA",
        DMA,
        dma_init,
        dma_open,
        dma_close,
        dma_driver_entry
    },
    
    {
        "MINI2440_TIMERs",
        TIMERs,
        timer_init,
        timer_open,
        timer_close,
        timer_driver_entry
    },
    
    {
        "MINI2440_INTs_CTRL",
        INTs,
        ints_ctrl_init,
        ints_ctrl_open,
        ints_ctrl_close,
        ints_ctrl_driver_entry
    },
    
    
    {0, 0, 0, 0, 0, 0}  //end
};

