//--------------------------------------------------------------------------
//Copyright(c) 2009, WenZhong Sun<wanmyqawdr@126.com>
//--------------------------------------------------------------------------
//This file is part of ARMV4T_and_FPGA_based_DSO
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

//--------------------------------------------------------------------------
// driver for interupts controller
//--------------------------------------------------------------------------

#include "../../../inc/typedef.h"
#include "../../../inc/ddf_api.h"
#include "./ints_ctrl.h"

BEGIN_IO_REQUEST_MAP(io_request_map)
    IOCTL_ROUTINE(IOCTL_TIMER_INT_DISABLE, ints_ctrl_timer_int_disable)
    IOCTL_ROUTINE(IOCTL_TIMER_INT_ENABLE, ints_ctrl_timer_int_enable)
    
//    IOCTL_ROUTINE(IOCTL_CPU_IRQ_DISABLE, ints_ctrl_cpu_irq_disable)
//    IOCTL_ROUTINE(IOCTL_CPU_IRQ_ENABLE, ints_ctrl_cpu_irq_enable)
END_IO_REQUEST_MAP()

static INT_REG * const regs = (PINT_REG)0x4a000000;

INT ints_ctrl_init(void)
{
/*
    UINT msk = BIT0;

    //mask all interrupt sources
    regs->INTMSK = 0xffffffff;
*/

    //all interrupts are in IRQ mode
    regs->INTMOD = 0x0;

/*    
    //clear pend registers
    while(msk){
        regs->SRCPND = msk;
        
        regs->INTPND = msk;
        
        while(regs->INTPND)
            continue;
        
        msk <<= 1;
    }
*/
            
/*
    //clear all pending interrupt sources
    regs->SRCPND = 0xffffffff;
    //clear all asserted interrupt sources
    regs->INTPND = 0xffffffff;
    
    //wait until pend registers have been cleard
    while(regs->SRCPND || regs->INTPND)
        continue;
*/    
    return DDF_SUCCESS;
}

UID ints_ctrl_open(UINT major, UINT minor)
{
    return DDF_SUCCESS;
}

INT ints_ctrl_close(UINT major, UINT minor)
{
    return DDF_SUCCESS;
}

INT ints_ctrl_driver_entry(
            UINT            ioctl, 
    const   BUFFER_OBJ *   pbuffer_in, 
            BUFFER_OBJ *   pbuffer_out
    )
{
    return _ddf_driver_dispatch(
                io_request_map, 
                ioctl, 
                pbuffer_in, 
                pbuffer_out
                );
}

INT ints_ctrl_timer_int_enable(
    const   BUFFER_OBJ *    pbuffer_in, 
            BUFFER_OBJ *    pbuffer_out
    )
{
    switch((UINT)pbuffer_in)
    {
    case 4:
        regs->INTMSK &= ~BIT14;
        return DDF_SUCCESS;
    default:
        return DDF_PARAMETER_ERROR;
    }
}
            
INT ints_ctrl_timer_int_disable(
    const   BUFFER_OBJ *    pbuffer_in, 
            BUFFER_OBJ *    pbuffer_out
    )
{
    switch((UINT)pbuffer_in)
    {
    case 4:
        regs->INTMSK |= BIT14;
        return DDF_SUCCESS;
    default:
        return DDF_PARAMETER_ERROR;
    }
}

INT ints_ctrl_cpu_irq_enable(
    const   BUFFER_OBJ *    pbuffer_in,
            BUFFER_OBJ *    pbuffer_out
    )
{
    cpu_irq_enable();
    return DDF_SUCCESS;
}

INT ints_ctrl_cpu_irq_disable(
    const   BUFFER_OBJ *    pbuffer_in,
            BUFFER_OBJ *    pbuffer_out
    )
{
    cpu_irq_disable();
    return DDF_SUCCESS;
}