//--------------------------------------------------------------------------
//Copyright(c) 2009, WenZhong Sun<wanmyqawdr@126.com>
//--------------------------------------------------------------------------
//This file is part of ARMV4T_and_FPGA_based_DSO
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

//--------------------------------------------------------------------------
//
//--------------------------------------------------------------------------

#ifndef _S3C2440_REGS_H_
#define _S3C2440_REGS_H_

#ifdef __cplusplus
extern"C"{
#endif
//_uart_reg X should be located at 0x5000_0000, 
//0x5000_4000 and 0x5000_8000
typedef struct _uart_reg{
    volatile UINT ULCON;
    volatile UINT UCON;
    volatile UINT UFCON;
    volatile UINT UMCON;
    volatile UINT UTRSTAT;
    volatile UINT UERSTAT;
    volatile UINT UFSTAT;
    volatile UINT UMSTAT;
    volatile UINT UTXH;
    volatile UINT URXH;
    volatile UINT UBRDIV;
}UART_REG, *PUART_REG;

//_lcd_reg should be located at 0x4d00_0000
typedef struct _lcd_reg{
    volatile UINT LCDCON1;
    volatile UINT LCDCON2;
    volatile UINT LCDCON3;
    volatile UINT LCDCON4;
    volatile UINT LCDCON5;
    volatile UINT LCDSADDR1;
    volatile UINT LCDSADDR2;
    volatile UINT LCDSADDR3;
    volatile UINT REDLUT;
    volatile UINT GREENLUT;
    volatile UINT BLUELUT;
    volatile UINT DITHMODE;
    volatile UINT TPAL;
    volatile UINT LCDINTPND;
    volatile UINT LCDSRCPND;
    volatile UINT LCDINTMSK;
    volatile UINT TCONSEL;
}LCD_REG, *PLCD_REG;

//_adc_reg should be located at 0x5800_0000
typedef struct _adc_reg{
    volatile UINT ADCCON;
    volatile UINT ADCTSC;
    volatile UINT ADCDLY;
    volatile UINT ADCDAT0;
    volatile UINT ADCDAT1;
    volatile UINT ADCUPDN;
}ADC_REG, *PADC_REG;

//_mem_reg should be located at 0x4800_0000
typedef struct _mem_reg{
    volatile UINT BWSCON;
    volatile UINT BANKCON0;
    volatile UINT BANKCON1;
    volatile UINT BANKCON2;
    volatile UINT BANKCON3;
    volatile UINT BANKCON4;
    volatile UINT BANKCON5;
    volatile UINT BANKCON6;
    volatile UINT BANKCON7;
    volatile UINT REFRESH;
    volatile UINT BANKSIZE;
    volatile UINT MRSRB6;
    volatile UINT MRSRB7;
}MEM_REG, *PMEM_REG;

//_dma_reg X should be located at 0x4b00_0000, 
//0x4b00_0040, 0x4b00_0080 and 0x4b00_00c0
typedef struct _dma_reg{
    volatile UINT DISRC;
    volatile UINT DISRCC;
    volatile UINT DIDST;
    volatile UINT DIDSTC;
    volatile UINT DCON;
    volatile UINT DSTAT;
    volatile UINT DCSRC;
    volatile UINT DCDST;
    volatile UINT DMASKTRIG;
}DMA_REG, *PDMA_REG;

//_int_reg should be located at 0x4a00_0000
typedef struct _int_reg{
    volatile UINT SRCPND;
    volatile UINT INTMOD;
    volatile UINT INTMSK;
    volatile UINT PRIORITY;
    volatile UINT INTPND;
    volatile UINT INTOFFSET;
    volatile UINT SUBSRCPND;
    volatile UINT INTSUBMSK;
}INT_REG, *PINT_REG;

//_gpio_reg should be located at 0x5600_0000
typedef struct _gpio_reg{
    volatile UINT GPACON;
    volatile UINT GPADAT;
    volatile UINT reserved_a;
    volatile UINT reserved_b;
    volatile UINT GPBCON;
    volatile UINT GPBDAT;
    volatile UINT GPBUP;
    volatile UINT reserved_c;
    volatile UINT GPCCON;
    volatile UINT GPCDAT;
    volatile UINT GPCUP;
    volatile UINT reserved_d;
    volatile UINT GPDCON;
    volatile UINT GPDDAT;
    volatile UINT GPDUP;
    volatile UINT reserved_e;
    volatile UINT GPECON;
    volatile UINT GPEDAT;
    volatile UINT GPEUP;
    volatile UINT reserved_f;
    volatile UINT GPFCON;
    volatile UINT GPFDAT;
    volatile UINT GPFUP;
    volatile UINT reserved_g;
    volatile UINT GPGCON;
    volatile UINT GPGDAT;
    volatile UINT GPGUP;
    volatile UINT reserved_h;
    volatile UINT GPHCON;
    volatile UINT GPHDAT;
    volatile UINT GPHUP;
    volatile UINT reserved_i;
    volatile UINT GPJCON;
    volatile UINT GPJDAT;
    volatile UINT GPJUP;
    volatile UINT reserved_j;
    volatile UINT MISCCR;
    volatile UINT DCLKCON;
    volatile UINT EXTINT0;
    volatile UINT EXTINT1;
    volatile UINT EXTINT2;
    volatile UINT EINTFLT0;
    volatile UINT EINTFLT1;
    volatile UINT EINTFLT2;
    volatile UINT EINTFLT3;
    volatile UINT EINTMASK;
    volatile UINT EINTPEND;
    volatile UINT GSTATUS0;
    volatile UINT GSTATUS1;
    volatile UINT GSTATUS2;
    volatile UINT GSTATUS3;
    volatile UINT GSTATUS4;
    volatile UINT reserved_k;
    volatile UINT DSC0;
    volatile UINT DSC1;
    volatile UINT MSLCON;
}GPIO_REG, *PGPIO_REG;

//_timer_reg should be located at 0x5100_0000
typedef struct _timer_reg{
    volatile UINT TCFG0;
    volatile UINT TCFG1;
    volatile UINT TCON;
    volatile UINT TCNTB0;
    volatile UINT TCMPB0;
    volatile UINT TCNTO0;
    volatile UINT TCNTB1;
    volatile UINT TCMPB1;
    volatile UINT TCNTO1;
    volatile UINT TCNTB2;
    volatile UINT TCMPB2;
    volatile UINT TCNTO2;
    volatile UINT TCNTB3;
    volatile UINT TCMPB3;
    volatile UINT TCNTO3;
    volatile UINT TCNTB4;
    volatile UINT TCNTO4;
}TIMER_REG, *PTIMER_REG;

void __inline clean_pending(INT_REG * regs)
{
    register UINT r;
    
    regs->SRCPND = BIT0 << regs->INTOFFSET;
    regs->INTPND = BIT0 << regs->INTOFFSET;
    
    //make sure that IRQ line has been deasserted before reenable IRQ
    r = regs->INTPND;
}

#ifdef __cplusplus
}
#endif

#endif