//--------------------------------------------------------------------------
//Copyright(c) 2009, WenZhong Sun<wanmyqawdr@126.com>
//--------------------------------------------------------------------------
//This file is part of ARMV4T_and_FPGA_based_DSO
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
#include "../../../inc/typedef.h"
#include "../../../inc/driver.h"
#include "../../../inc/task.h"
#include "../../../inc/gui.h"
#include "../../ddf/ddf_core.h"
#include <stdio.h>
#include <stdlib.h>

// -- Structure --
// "__FILE", alise "FILE"
// user defined type to tailoring C Lib
struct __FILE{ 
    void * handle;   
    UINT type;
};

extern "C" void _enter_user_mode(void);
extern "C" void _kernel_init(void);

// *** _stdin_out_stream_init ***
// -- Description --
// retarget __stdin, __stdout and __stderr to uart
// which will be used by printf, scanf ...
// -- Parameters --
//      None
// -- Return --
//      None
static void _stdin_out_stream_init(void)
{
    extern FILE __stdout, __stdin, __stderr;
    PDEVICE_OBJ _std_stream;
    
    _std_stream = (PDEVICE_OBJ)malloc(sizeof(DEVICE_OBJ));
    ddf_DeviceOpen(_std_stream, UART, 0);
    
    __stdout.handle = _std_stream;
    __stdout.type = UART;
    
    __stdin.handle = _std_stream;
    __stdin.type = UART;
    
    __stderr.handle = _std_stream;
    __stderr.type = UART;
}

// *** _c_init ***
// -- Description --
// initialize DDF, __stdin, __stdout.
// -- Parameters --
//      None
// -- Return --
// SUCCESS, FAILURE
// -- Note --
// this function will be invoked automatically, and do not invoke it again!!!
void _c_init(void)
{
    
    DEVICE_OBJ error_dev;
    
    _kernel_init();
    
    _ddf_init(&error_dev);
    
    _stdin_out_stream_init();
    
    _gui_init();
    
    _enter_user_mode();
}











