//--------------------------------------------------------------------------
//Copyright(c) 2009, WenZhong Sun<wanmyqawdr@126.com>
//--------------------------------------------------------------------------
//This file is part of ARMV4T_and_FPGA_based_DSO
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

//--------------------------------------------------------------------------
//This file contains functions for tailoring C Lib
//--------------------------------------------------------------------------

#include "../../../inc/typedef.h"
#include "../../../inc/driver.h"
#include <rt_sys.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

//Make sure all the programs don't use any semihoting function
#pragma import(__use_no_semihosting_swi)

void _sys_exit(int return_code)
{
    printf("program exit with returned code %d.\n", return_code);
    while(1)
        continue;
}

void _ttywrch(int ch)
{
    while(1)
        continue;
}

struct __FILE{ 
    void * handle;   
    UINT type;
};

FILE __stdout;
FILE __stdin;
FILE __stderr;

/*int *fclose(FILE * pfile)
{
}*/

int ferror(FILE *f)
{  
    return EOF;
}


int fputc(int ch, FILE * pfile)
{
    //"pfile" is the pointor of "__stdout" we have setup in "c_init()" 
    
    //call uart dirver to send the char
    ddf_DeviceIoControl(
        IOCTL_UART_SEND_CHAR, 
        (PDEVICE_OBJ)pfile->handle, 
        (PBUFFER_OBJ)ch, 
        0
        );
        
    return ch;
}

int fgetc(FILE * pfile)
{
    //"pfile" is the pointor of "__stdin" we have setup in "c_init()" 
    static int mark = 0;
    int ch;
    
    if(mark){
        mark = 0;
        return EOF;
    }
    
    //call uart driver to get a char
    ddf_DeviceIoControl(
        IOCTL_UART_GET_CHAR, 
        (PDEVICE_OBJ)pfile->handle, 
        0, 
        (PBUFFER_OBJ)&ch
        );
        
    //call uart driver to echo the char we got before
    ddf_DeviceIoControl(
        IOCTL_UART_SEND_CHAR, 
        (PDEVICE_OBJ)pfile->handle, 
        (PBUFFER_OBJ)ch, 
        0
        );
    
    if(ch == '\r'){
        mark = 1;
        return 0;
    }else{
        return ch;
    }
}





