;--------------------------------------------------------------------------
;Copyright(c) 2009, WenZhong Sun<wanmyqawdr@126.com>
;--------------------------------------------------------------------------
;This file is part of ARMV4T_and_FPGA_based_DSO

;This program is free software; you can redistribute it and/or
;modify it under the terms of the GNU General Public License
;as published by the Free Software Foundation; either
;version 2 of the License, or (at your option) any later version.

;This program is distributed in the hope that it will be useful,
;but WITHOUT ANY WARRANTY; without even the implied warranty of
;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;GNU General Public License for more details.

;You should have received a copy of the GNU General Public License
;along with this program; if not, write to the Free Software
;Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
;--------------------------------------------------------------------------

;--------------------------------------------------------------------------
; -- This file contains functions for tailoring C Lib
;--------------------------------------------------------------------------
    GET ./options.inc
    
    AREA C_LIB_TAILORING_S, CODE, READONLY
    
; -- CODE
    
; -- Use alternative heap implementation
    IMPORT __use_realtime_heap
    
; -- Use two memory regions,one is for the stack,the other is for the heap
    IMPORT __use_two_region_memory
    
    EXPORT __user_initial_stackheap
; -- The values returned in r0 - r3 respectively the heap base, stack base,
; -- heap limit and stack limit, maintain 8-byte alignment of the heap.
__user_initial_stackheap
    LDR r0, =HEAP_BASE      
    LDR r1, =STACK_USER
    LDR r2, =HEAP_LIMIT
    LDR r3, =STACK_LIMIT
    MOV pc, lr
    
    EXPORT __user_heap_extent
; -- r0 - heap_base
; -- r1 - heap_range
__user_heap_extent
    LDR r0, =HEAP_BASE
    LDR r1, =HEAP_SIZE
    MOV pc, lr
    
;    EXPORT __rt_fp_status_addr
; -- Returned by r0 is address of the float_point status register,
; -- this may be necessary ...
;__rt_fp_status_addr
;    LDR r0, =FP_STATUS_ADDR
;    MOV pc, lr
    
    END