;--------------------------------------------------------------------------
;Copyright(c) 2009, WenZhong Sun<wanmyqawdr@126.com>
;--------------------------------------------------------------------------
;This file is part of ARMV4T_and_FPGA_based_DSO

;This program is free software; you can redistribute it and/or
;modify it under the terms of the GNU General Public License
;as published by the Free Software Foundation; either
;version 2 of the License, or (at your option) any later version.

;This program is distributed in the hope that it will be useful,
;but WITHOUT ANY WARRANTY; without even the implied warranty of
;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;GNU General Public License for more details.

;You should have received a copy of the GNU General Public License
;along with this program; if not, write to the Free Software
;Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
;--------------------------------------------------------------------------

;--------------------------------------------------------------------------
; -- This file contains functions about CP15
;--------------------------------------------------------------------------    
    GET ./options.inc
    
    AREA CP15, CODE, READONLY
    
; -- CODE
    
;void _cp15_SetAsyncBusMode(void)
    EXPORT _cp15_SetAsyncBusMode
_cp15_SetAsyncBusMode  
    MRC p15, 0, r0, c1, c0, 0
    ORR r0, r0, #iA|nF
    MCR p15, 0, r0, c1, c0, 0
    MOV pc, lr
    
;void _cp15_SetFastBusMode(void)
    EXPORT _cp15_SetFastBusMode
_cp15_SetFastBusMode
    MRC p15, 0, r0, c1, c0, 0
    BIC r0, r0, #iA|nF
    MCR p15, 0, r0, c1, c0, 0
    MOV pc, lr

;void _cp15_DCache_enable(void)    
    EXPORT _cp15_DCache_enable
_cp15_DCache_enable
    MRC p15, 0, r0, c1, c0, 0
    ORR r0, r0, #C
    MCR p15, 0, r0, c1, c0, 0
    MOV pc, lr

;void _cp15_DCache_disable(void)    
    EXPORT _cp15_DCache_disable
_cp15_DCache_disable
    MRC p15, 0, r0, c1, c0, 0
    BIC r0, r0, #C
    MCR p15, 0, r0, c1, c0, 0
    MOV pc, lr
    
;void _cp15_DCache_flush(void)    
    EXPORT _cp15_DCache_flush
_cp15_DCache_flush
    MOV r0, #0
    MCR p15, 0, r0, c7, c6, 0
    MOV pc, lr

;void _cp15_DCache_clean(void)    
    EXPORT _cp15_DCache_clean
_cp15_DCache_clean
    MOV r0, #0
1       
    ;c7[7:5] = seg;
    ;c7[31:26] = index;  
    MCR p15, 0, r0, c7, c10, 2
    
    ADD r0, r0, #1<<5      ;seg++
    TST r0, #1<<8          ;seg > 7 ?
    BEQ %B1             
    
    BIC r0, r0, #1<<8      ;clear c7[8]
    ADDS r0, r0, #1<<26    ;index++
    BCC %B1                ;if index <= 63 jump to %1
    MOV pc, lr

;void _cp15_ICache_enable(void)    
    EXPORT _cp15_ICache_enable
_cp15_ICache_enable
    MRC p15, 0, r0, c1, c0, 0
    ORR r0, r0, #I
    MCR p15, 0, r0, c1, c0, 0
    MOV pc, lr

;void _cp15_ICache_disable(void)     
    EXPORT _cp15_ICache_disable
_cp15_ICache_disable
    MRC p15, 0, r0, c1, c0, 0
    BIC r0, r0, #I
    MCR p15, 0, r0, c1, c0, 0
    MOV pc, lr
    
;void _cp15_ICache_flush(void)    
    EXPORT _cp15_ICache_flush
_cp15_ICache_flush
    MOV r0, #0
    MCR p15, 0, r0, c7, c5, 0
    MOV pc, lr
    
;void _cp15_mmu_enable(void)
    EXPORT _cp15_mmu_enable
_cp15_mmu_enable
    MRC p15, 0, r0, c1, c0, 0
    ORR r0, r0, #M
    MCR p15, 0, r0, c1, c0, 0
    MOV pc, lr

;void _cp15_mmu_disable(void)    
    EXPORT _cp15_mmu_disable
_cp15_mmu_disable    
    MRC p15, 0, r0, c1, c0, 0
    BIC r0, r0, #M
    MCR p15, 0, r0, c1, c0, 0
    MOV pc, lr

;void _cp15_mmu_tlb_flush(void)    
    EXPORT _cp15_mmu_tlb_flush
_cp15_mmu_tlb_flush
    MOV r0, #0
    MCR p15, 0, r0, c8, c7, 0
    MOV pc, lr

;void _cp15_mmu_ttb_set(unsigned int * ttb)    
    EXPORT _cp15_mmu_ttb_set
_cp15_mmu_ttb_set
    MCR p15, 0, r0, c2, c0, 0
    MOV pc, lr
    
;void _cp15_mmu_domain_set(unsigned int val)
    EXPORT _cp15_mmu_domain_set
_cp15_mmu_domain_set
    MCR p15, 0, r0, c3, c0, 0
    MOV pc, lr

;void _cp15_mmu_process_id_set(unsigned int pid)    
    EXPORT _cp15_mmu_process_id_set
_cp15_mmu_process_id_set
    MCR p15, 0, r0, c13, c0, 0
    MOV pc, lr
    
    END