//--------------------------------------------------------------------------
//Copyright(c) 2009, WenZhong Sun<wanmyqawdr@126.com>
//--------------------------------------------------------------------------
//This file is part of ARMV4T_and_FPGA_based_DSO
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

//--------------------------------------------------------------------------
//--------------------------------------------------------------------------
#include "../inc/typedef.h"
#include "./swi.h"
#include "./ddf/ddf_type.h"
#include "./ddf/ddf_core.h"


// *** swi_handler_dispatch ***
// -- Descprition -- 
// system_SWI_handler call this function to dispatch SWI to a specified routine
// -- Parameters --
// 1) "swi_number", is a specified system request number
// 2) "r", system_SWI_handler, the caller, has saved r0 - r12, lr, spsr in 
//    user mode to SVC stack, the start address of the SVC stack will be the
//    second parameter for swi_handler_dispatch, also be "r"
// -- Return --
// "swi_handler_dispatch" write returned value to SVC stack, 
// and "system_SWI_handler" will restore the returned value in SVC 
// stack when it return.
                                         
UINT swi_handler_dispatch(UINT swi_number, PUINT pRegs)
{
    switch(swi_number)
    {
    case SYSTEM:   
        pRegs[0] = 0;
        break;
    default: 
        //enter_sys_mode();       
        pRegs[0] = _ddf_request_dispatch(pRegs);
        //exit_sys_mode();
    }
    
    return 1;
}