;--------------------------------------------------------------------------
;Copyright(c) 2009, WenZhong Sun<wanmyqawdr@126.com>
;--------------------------------------------------------------------------
;This file is part of ARMV4T_and_FPGA_based_DSO

;This program is free software; you can redistribute it and/or
;modify it under the terms of the GNU General Public License
;as published by the Free Software Foundation; either
;version 2 of the License, or (at your option) any later version.

;This program is distributed in the hope that it will be useful,
;but WITHOUT ANY WARRANTY; without even the implied warranty of
;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;GNU General Public License for more details.

;You should have received a copy of the GNU General Public License
;along with this program; if not, write to the Free Software
;Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
;--------------------------------------------------------------------------

;--------------------------------------------------------------------------
; -- This file contains intrrupt vectors table 
;----------------------- ---------------------------------------------------

    GET ./mini2440/target/options.inc
    
; -- IMPORT 

    IMPORT system_initialize
    IMPORT system_undefined_handler
    IMPORT system_SWI_handler
    IMPORT system_prefetch_abort_handler
    IMPORT system_data_abort_handler
    IMPORT system_reserved_handler
    IMPORT system_IRQ_handler
    IMPORT system_FIQ_handler
  
; -- IMPORT END    

    AREA VECTORS_TABLE, CODE, READONLY
    
; -- CODE

    ENTRY 
;--------------------------------------------------------------------------    
; -- interrupt table 
; Table offset ...
; 00 - Reset
; 04 - Undefined instructions
; 08 - SWI instructions 
; 0C - Prefetch abort
; 10 - Data abort
; 14 - Reserved
; 18 - IRQ interrupts
; 1C - FIQ interrupts
;--------------------------------------------------------------------------
    B   system_initialize
    B   system_undefined_handler
    B   system_SWI_handler
    B   system_prefetch_abort_handler
    B   system_data_abort_handler
    B   system_reserved_handler
    B   system_IRQ_handler
    B   system_FIQ_handler
    

    ; LDR pc, vector_reset
    ; LDR pc, =vector_undefined
    ; LDR pc, =vector_SWI
    ; LDR pc, =vector_prefetch_abort
    ; LDR pc, =vector_data_abort
    ; LDR pc, =vector_reserved     ;vector_reserved
    ; LDR pc, =vector_IRQ
    ; LDR pc, =vector_FIQ
    
; vector_reset                 DCD         system_initialize


    
; vector_undefined        HANDLER     vector_undefined_post
; vector_SWI              HANDLER     vector_SWI_post
; vector_prefetch_abort   HANDLER     vector_prefetch_abort_post
; vector_data_abort       HANDLER     vector_data_abort_post
; vector_reserved         HANDLER     vector_reserved_post
; vector_IRQ              HANDLER     vector_IRQ_post
; vector_FIQ              HANDLER     vector_FIQ_post
    
; ; -- Fill vectors_table
; ; -- This function should be invoked after initialize memory controller
    ; EXPORT fill_vectors_table
; fill_vectors_table
; ; -- Entry of undefined handler at VECTORS_TABLE_BASE
    ; LDR r0, =vector_undefined_post
    ; LDR r1, =system_undefined_handler
    ; STR r1, [r0]
; ; -- Entry of SWI handler at VECTORS_TABLE_BASE + 0x04  
    ; LDR r0, =vector_SWI_post
    ; LDR r1, =system_SWI_handler
    ; STR r1, [r0]
; ; -- Entry of prefetch abort handler at VECTORS_TABLE_BASE + 0x08
    ; LDR r0, =vector_prefetch_abort_post
    ; LDR r1, =system_prefetch_abort_handler
    ; STR r1, [r0]
; ; -- Entry of data_abort handler at VECTORS_TABLE_BASE + 0x1c    
    ; LDR r0, =vector_data_abort_post 
    ; LDR r1, =system_data_abort_handler
    ; STR r1, [r0]
; ; -- Entry of reserved handler at VECTORS_TABLE_BASE + 0x20    
    ; LDR r0, =vector_reserved_post
    ; LDR r1, =system_reserved_handler
    ; STR r1, [r0]
; ; -- Entry of IRQ handler at VECTORS_TABLE_BASE + 0x24    
    ; LDR r0, =vector_IRQ_post
    ; LDR r1, =system_IRQ_handler
    ; STR r1, [r0]
; ; -- Entry of FIQ handler at VECTORS_TABLE_BASE + 0x28
    ; LDR r0, =vector_FIQ_post
    ; LDR r1, =system_FIQ_handler
    ; STR r1, [r0]
    
    ; MOV pc, lr      ;end
    
    ; AREA VECTORS_JUMP_TABLE, DATA, READWRITE
    
; ; -- DATA

    ; MAP VECTORS_JUMP_TABLE_BASE 
; vector_undefined_post            FIELD           4
; vector_SWI_post                  FIELD           4
; vector_prefetch_abort_post       FIELD           4
; vector_data_abort_post           FIELD           4
; vector_reserved_post             FIELD           4 
; vector_IRQ_post                  FIELD           4
; vector_FIQ_post                  FIELD           4

    END
    